


#include "Effets.h"
#include "Affichages.h"
#include "Utilitaires.h"



const unsigned char CoordonneesX[57] = {0, 1, 2, 3, 4, 5, 6, 7, 7, 6, 6, 5, 4, 3, 2, 2, 3, 3, 3, 3, 2, 2, 2, 1, 1, 1, 1, 2, 3, 4, 5, 6, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7, 7, 7, 7, 6, 5, 4, 4, 5, 5, 5, 5, 6, 6, 6, 7};
const unsigned char CoordonneesY[57] = {0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 2, 2, 2, 2, 2, 3, 3, 4, 5, 6, 6, 5, 4, 4, 3, 2, 1, 1, 1, 1, 1, 1, 2, 3, 4, 5, 6, 7, 7, 6, 5, 4, 3, 2, 1, 1, 1, 1, 2, 2, 3, 4, 5, 5, 6, 7, 7};



const unsigned char Tailles0[64] =     {1, 2, 3, 4, 5, 6, 7, 8, 5, 6, 1, 2, 3, 7, 5, 8, 6, 4, 1, 1, 3, 6, 5, 5, 4, 4, 1, 2, 3, 8, 8, 7, 1, 3, 6, 4, 6, 4, 4, 4, 5, 6, 2, 2, 3, 5, 4, 2, 5, 6, 3, 1, 2, 8, 4, 6, 8, 6, 2, 6, 2, 3, 2, 1};
const unsigned char Tailles1[64] = {1, 4, 5, 6, 3, 2, 2, 4, 1, 8, 7, 8, 2, 5, 6, 2, 3, 4, 3, 7, 2, 7, 7, 7, 5, 6, 2, 2, 1, 4, 4, 7, 8, 1, 2, 5, 6, 4, 4, 1, 5, 6, 7, 8, 6, 3, 5, 6, 6, 4, 2, 3, 7, 8, 2, 1, 4, 3, 4, 5, 6, 2, 6, 1};
const unsigned char Tailles2[64] = {1, 3, 3, 4, 5, 3, 4, 8, 5, 6, 1, 2, 3, 7, 5, 8, 6, 4, 1, 1, 3, 6, 5, 5, 4, 8, 1, 2, 7, 8, 8, 7, 1, 3, 6, 4, 6, 4, 4, 4, 5, 6, 2, 2, 3, 5, 4, 6, 5, 6, 3, 1, 2, 8, 4, 6, 5, 6, 2, 6, 3, 3, 2, 1};
const unsigned char Tailles3[64] = {1, 6, 8, 1, 8, 2, 1, 2, 5, 6, 6, 2, 5, 1, 2, 6, 3, 1, 7, 2, 4, 2, 1, 8, 8, 1, 6, 6, 4, 3, 2, 7, 8, 3, 7, 1, 1, 8, 2, 5, 5, 2, 1, 2, 7, 5, 1, 2, 2, 1, 5, 4, 5, 4, 3, 2, 2, 1, 3, 7, 2, 1, 8, 1};



void RemplirLignes(unsigned char Direction, int Transitions)
{
	unsigned char k;

	EteindreMatrice();

	for(k = 0; k < 8; k++)
	{
		ActiverEnsemble(Direction, k, 0xFF);

		Scrutation(Transitions);
	}

	EteindreMatrice();
}



void CroiserLignes(int Transitions)
{
	unsigned char k;

	for(k = 0; k < 8; k++)
	{
		EteindreMatrice();

		ActiverEnsemble('X', k, 0xFF);
		ActiverEnsemble('Y', k, 0xFF);

		Scrutation(Transitions);
	}
}



void BalayerLignes(unsigned char Direction, int Transitions)
{
	unsigned char k;

	EteindreMatrice();

	for(k = 0; k < 8; k++)
	{
		EteindreMatrice();

		ActiverEnsemble(Direction, k, 0xFF);

		Scrutation(Transitions);
	}

	EteindreMatrice();
}






void EffetPointsVariables(unsigned char Nombres, int Transitions)
{
	unsigned char k;



		EteindrePoint((Tailles0[63] - 1), (Tailles1[63] - 1));
		Scrutation(Transitions);

		AfficherPoint((Tailles0[0] - 1), (Tailles1[0] - 1));
		Scrutation(Transitions);



		EteindrePoint((Tailles1[63] - 1), (Tailles2[63] - 1));
		Scrutation(Transitions);

		AfficherPoint((Tailles1[0] - 1), (Tailles2[0] - 1));
		Scrutation(Transitions);



		EteindrePoint((Tailles2[63] - 1), (Tailles3[63] - 1));
		Scrutation(Transitions);

		AfficherPoint((Tailles2[0] - 1), (Tailles3[0] - 1));
		Scrutation(Transitions);



		EteindrePoint((Tailles3[63] - 1), (Tailles0[63] - 1));
		Scrutation(Transitions);

		AfficherPoint((Tailles3[0] - 1), (Tailles0[0] - 1));
		Scrutation(Transitions);



		EteindrePoint((Tailles0[63] - 1), (Tailles2[63] - 1));
		Scrutation(Transitions);

		AfficherPoint((Tailles0[0] - 1), (Tailles2[0] - 1));
		Scrutation(Transitions);



		EteindrePoint((Tailles1[63] - 1), (Tailles2[63] - 1));
		Scrutation(Transitions);

		AfficherPoint((Tailles1[0] - 1), (Tailles2[0] - 1));
		Scrutation(Transitions);



		EteindrePoint((Tailles2[63] - 1), (Tailles0[63] - 1));
		Scrutation(Transitions);

		AfficherPoint((Tailles2[0] - 1), (Tailles0[0] - 1));
		Scrutation(Transitions);



	for(k = 1; k < 64; k++)
	{
		EteindrePoint((Tailles0[k - 1] - 1), (Tailles1[k - 1] - 1));
		Scrutation(Transitions);

		AfficherPoint((Tailles0[k] - 1), (Tailles1[k] - 1));
		Scrutation(Transitions);



		EteindrePoint((Tailles1[k - 1] - 1), (Tailles2[k - 1] - 1));
		Scrutation(Transitions);

		AfficherPoint((Tailles1[k] - 1), (Tailles2[k] - 1));
		Scrutation(Transitions);



		EteindrePoint((Tailles2[k - 1] - 1), (Tailles3[k - 1] - 1));
		Scrutation(Transitions);

		AfficherPoint((Tailles2[k] - 1), (Tailles3[k] - 1));
		Scrutation(Transitions);



		EteindrePoint((Tailles3[k - 1] - 1), (Tailles0[k - 1] - 1));
		Scrutation(Transitions);

		AfficherPoint((Tailles3[k] - 1), (Tailles0[k] - 1));
		Scrutation(Transitions);



		if(Nombres != 7)
		{
	
			EteindrePoint((Tailles0[k - 1] - 1), (Tailles2[k - 1] - 1));
			Scrutation(Transitions);
	
			AfficherPoint((Tailles0[k] - 1), (Tailles2[k] - 1));
			Scrutation(Transitions);

	
	
			EteindrePoint((Tailles0[k - 1] - 1), (Tailles2[k - 1] - 1));
			Scrutation(Transitions);
	
			AfficherPoint((Tailles0[k] - 1), (Tailles2[k] - 1));
			Scrutation(Transitions);
	
	
	
			EteindrePoint((Tailles1[k - 1] - 1), (Tailles2[k - 1] - 1));
			Scrutation(Transitions);
	
			AfficherPoint((Tailles1[k] - 1), (Tailles2[k] - 1));
			Scrutation(Transitions);
	
	
	
			EteindrePoint((Tailles2[k - 1] - 1), (Tailles0[k - 1] - 1));
			Scrutation(Transitions);
	
			AfficherPoint((Tailles2[k] - 1), (Tailles0[k] - 1));
			Scrutation(Transitions);
		}
	}
}



void EffetSerpent(int Transitions)
{
	unsigned char k;
	unsigned char l;
	unsigned char v;



	EteindreMatrice();



	for(k = 0; k < 7; k++)
	{
		AfficherPoint(CoordonneesX[k], CoordonneesY[k]);
		Scrutation(Transitions);
	}


	for(l = 7; l < 57; l++)
	{
		EteindrePoint(CoordonneesX[l - 7], CoordonneesY[l - 7]);
		AfficherPoint(CoordonneesX[l], CoordonneesY[l]);
		Scrutation(Transitions);
	}



	for(v = 50; v < 57; v++)
	{
		EteindrePoint(CoordonneesX[v], CoordonneesY[v]);
		Scrutation(Transitions);
	}



	EteindreMatrice();
}



void EffetCoins(unsigned char Longueur, unsigned char Volume, int Transitions)
{
	unsigned char k;

	EteindreMatrice();



	for(k = 1; k <= 8; k++)
	{
		AfficherCoin(Longueur, k, Volume);
	}



	Scrutation(Transitions);



	EteindreMatrice();
}



void EffetCarreCentre(unsigned char Direction, int Transitions)
{
	if(Direction == 0)
	{
		EteindreMatrice();
		AfficherRectangle(0, 0, 8, 8);

		Scrutation(Transitions);



		EteindreMatrice();
		AfficherRectangle(1, 1, 6, 6);

		Scrutation(Transitions);



		EteindreMatrice();
		AfficherRectangle(2, 2, 4, 4);

		Scrutation(Transitions);



		EteindreMatrice();
		AfficherRectangle(3, 3, 2, 2);

		Scrutation(Transitions);



	}
	else
	{
		EteindreMatrice();
		AfficherRectangle(3, 3, 2, 2);

		Scrutation(Transitions);



		EteindreMatrice();
		AfficherRectangle(2, 2, 4, 4);

		Scrutation(Transitions);



		EteindreMatrice();
		AfficherRectangle(1, 1, 6, 6);

		Scrutation(Transitions);



		EteindreMatrice();
		AfficherRectangle(0, 0, 8, 8);

		Scrutation(Transitions);



	}
}



void EffetCarreVariable(unsigned char Arete, int Transitions)
{
	unsigned char k;

	for(k = 1; k <= 8; k++)
	{
		EteindreMatrice();
		AfficherRectangle(0, 0, k, k);

		Scrutation(Transitions);

	}

	for(k = 1; k < 8; k++)
	{
		EteindreMatrice();
		AfficherRectangle(k, k, (8 - k), (8 - k));

		Scrutation(Transitions);

	}

	for(k = 7; k > 0; k--)
	{
		EteindreMatrice();
		AfficherRectangle(k, k, (8 - k), (8 - k));

		Scrutation(Transitions);

	}

	for(k = 8; k > 0; k--)
	{
		EteindreMatrice();
		AfficherRectangle(0, 0, k, k);

		Scrutation(Transitions);

	}

	for(k = 1; k <= 8; k++)
	{
		EteindreMatrice();
		AfficherRectangle(0, 0, k, k);

		Scrutation(Transitions);

	}

	for(k = 1; k < 8; k++)
	{
		EteindreMatrice();
		AfficherRectangle(0, k, (8 - k), (8 - k));

		Scrutation(Transitions);

	}

	for(k = 7; k > 0; k--)
	{
		EteindreMatrice();
		AfficherRectangle(0, k, (8 - k), (8 - k));

		Scrutation(Transitions);

	}

	for(k = 0; k < 8; k++)
	{
		EteindreMatrice();
		AfficherRectangle(k, 0, (8 - k), (8 - k));

		Scrutation(Transitions);

	}

	for(k = 7; k > 0; k--)
	{
		EteindreMatrice();
		AfficherRectangle(k, 0, (8 - k), (8 - k));

		Scrutation(Transitions);

	}

	for(k = 0; k < 8; k++)
	{
		EteindreMatrice();
		AfficherRectangle(0, k, (8 - k), (8 - k));

		Scrutation(Transitions);

	}

	for(k = 7; k > 0; k--)
	{
		EteindreMatrice();
		AfficherRectangle(0, k, (8 - k), (8 - k));

		Scrutation(Transitions);

	}

	for(k = 8; k > 0; k--)
	{
		EteindreMatrice();
		AfficherRectangle(0, 0, k, k);

		Scrutation(Transitions);

	}



}



void EffetCarreBaladeur(unsigned char Arete, int Transitions)
{
	EteindreMatrice();
	AfficherRectangle(0, 0, Arete, Arete);

	Scrutation(Transitions);



	EteindreMatrice();
	AfficherRectangle(1, 0, Arete, Arete);

	Scrutation(Transitions);



	EteindreMatrice();
	AfficherRectangle(3, 0, Arete, Arete);

	Scrutation(Transitions);



	EteindreMatrice();
	AfficherRectangle((8 - Arete), 0, Arete, Arete);

	Scrutation(Transitions);



	EteindreMatrice();
	AfficherRectangle((8 - Arete), 1, Arete, Arete);

	Scrutation(Transitions);



	EteindreMatrice();
	AfficherRectangle((8 - Arete), 3, Arete, Arete);

	Scrutation(Transitions);



	EteindreMatrice();
	AfficherRectangle((8 - Arete), (8 - Arete), Arete, Arete);

	Scrutation(Transitions);



	EteindreMatrice();
	AfficherRectangle(3, (8 - Arete), Arete, Arete);

	Scrutation(Transitions);



	EteindreMatrice();
	AfficherRectangle(1, (8 - Arete), Arete, Arete);

	Scrutation(Transitions);



	EteindreMatrice();
	AfficherRectangle(0, (8 - Arete), Arete, Arete);

	Scrutation(Transitions);



	EteindreMatrice();
	AfficherRectangle(0, 3, Arete, Arete);

	Scrutation(Transitions);



	EteindreMatrice();
	AfficherRectangle(0, 1, Arete, Arete);

	Scrutation(Transitions);



	EteindreMatrice();
	AfficherRectangle(0, 0, Arete, Arete);

	Scrutation(Transitions);



}



void EffetTexteDefilant(int Transitions, unsigned char Espacement, unsigned char Rotation, unsigned char Miroir, const unsigned char Texte[])
{
	unsigned char k;

	short int p = 0;
	short int Taille;

	Taille = Longueur(Texte);

	for(k = 0; k < (Taille * 8); k++)
	{
		for(p = 0; p < Taille; p++)
		{
			if(((k - (p * Espacement)) >= (-8)) && ((k - (p * Espacement)) <= 9))
			{
				AfficherCaractere((k - (p * Espacement)), 0, Rotation, Miroir, Texte[p]);
			}
		}
//		AfficherCaractere(k, 0, CARACTERE_ROTATION_0, CARACTERE_MIROIR_DESACTIVE, Texte[0]);
//		AfficherCaractere((k - 7), 0, CARACTERE_ROTATION_0, CARACTERE_MIROIR_DESACTIVE, Texte[1]);
//		AfficherCaractere((k - 7 * 2), 0, CARACTERE_ROTATION_0, CARACTERE_MIROIR_DESACTIVE, Texte[2]);
//		AfficherCaractere((k - 7 * 3), 0, CARACTERE_ROTATION_0, CARACTERE_MIROIR_DESACTIVE, Texte[3]);
		Scrutation(Transitions);
		EteindreMatrice();
	}
//		for(p = 0; p < 2; p++)
//		{
//			if(((k - (p * 7)) >= (-8)) && ((k - (p * 7)) <= 9))
//			{
//				AfficherCaractere((k - (p * 7)), 0, CARACTERE_ROTATION_0, CARACTERE_MIROIR_DESACTIVE, Texte[p]);
//			}
//			Scrutation(Transitions);
//			EteindreMatrice();
//		}
//	k = 0;
//	do
//	{
//		p++;
//		for(k = 0; k < 8; k++)
//		{
//			AfficherCaractere(k, 0, CARACTERE_ROTATION_0, CARACTERE_MIROIR_DESACTIVE, Texte[p]);
//			AfficherCaractere((k + 7), 0, CARACTERE_ROTATION_0, CARACTERE_MIROIR_DESACTIVE, Texte[p + 1]);
//			Scrutation(Transitions);
//			EteindreMatrice();
//		}
//	}
//	while(Texte[p] != '\0');
//	AfficherCaractere((p + 7), 0, CARACTERE_ROTATION_0, CARACTERE_MIROIR_DESACTIVE, Texte[k]);
//	for(k = 0; k < 9; k++)
//	{
//		for(p = -7; p < 8; p++)
//		{
//	 		AfficherCaractere((p + 7), 0, CARACTERE_ROTATION_0, CARACTERE_MIROIR_DESACTIVE, Texte[k]);
//			if(k < 8)
//			{
//				AfficherCaractere(p, 0, CARACTERE_ROTATION_0, CARACTERE_MIROIR_DESACTIVE, Texte[k + 1]);
//			}
//			if(k < 7)
//			{
//				if(p > 1)
//				{
//				 	AfficherCaractere((p + 7), 0, CARACTERE_ROTATION_0, CARACTERE_MIROIR_DESACTIVE, Texte[k + 2]);
//				}
//			}
//			Scrutation(Transitions);
//			EteindreMatrice();
//		}
//	}

	EteindreMatrice();
}

