


#include <stm32f10x.h>

#include "SPI.h"

#include "Utilitaires.h"



void InitSPI1(void)
{
	RCC->APB2ENR |= (1 << 0);	/* Activation de l'horloge pour les fonctions alternatives d'entres - sorties */
	RCC->APB2ENR |= (1 << 12);	/* Activation de l'horloge du module du SPI1 */

	GPIOA->CRL = ((GPIOA->CRL & 0xFFFFFFF0) | 0x00000003);	/* Configurations de la broche  PA0  - LOAD_MAX7219 en sortie de type  Push-Pull  */

	GPIOA->CRL = ((GPIOA->CRL & 0x0000FFFF) | 0xBBB00000);	/* Configurations des broches  PA5  - CLK_MAX7219,  PA6  et  PA7  - DIN_MAX7219 pour
	les fonctions alternatives d'entres - sorties. */
						
	SPI1->CR1 = 0x00004804;	/* Contenu du registre  SPI1->CR1  : 0b0100100000001100, ce qui correspond aux rglages indiqus ci-aprs,

							BIDIMODE = 0,
							BIDIOE = 1,
							CRCEN = 0,
							CRCNEXT = 0,
							DFF = 1, chaque transmission s'effectue sur 16 bits,
							CRCNEXT = 0, 
							RXONLY = 0,
							SSM = 0,
							LSBFIRST = 0, le bit de poids fort - le  MSB  - est transmis en premier,
							MSTR = 1, le module du SPI1 fonctionne en tant que matre,
							CPOL = 0,
							CPHA = 0 */

	SPI1->CR1 |= (2 << 3);	/* Configuration de la vitesse du module SPI1  f PCLK / 2 */

	SPI1->CR2 |= (1 << 2);	/* SSOE = 1. */

	SPI1->CR1 |= (1 << 6);	/* Activation du module du SPI1,
		 n'effectuer qu'une fois que ce dernier ait t compltement configur, ce qui consiste  effectuer :
		SPE = 1 */
}



void InitITSPI1(void)
{
	NVIC->ISER[1] |= (1 << 3);   /* L'interruption qui correspond au module du SPI1 est situe en position 35,
		dans la table des vecteurs. */
}



void SPI1_IRQHandler(void) __irq	/* Routine d'interruption appele par le module du SPI1. */
{
	if((SPI1->SR & 0x0002) && (!(SPI1->SR & (1 << 7))))	/* Si le module du SPI1 signale qu'il a fini d'tre utilis,
		c'est--dire si les 16 bits ont t envoys */
	{
		SPI1->CR2 &= ~(1 << 7);	/* Interdiction des interruptions provoques par le module du SPI1 */
	
		GPIOA->BSRR = (1 << 0);	/* LOAD_MAX7219 = 1 */
	}

	SPI1->SR = 0;	/* Rarmement de l'interruption appele par le module du SPI1 */
}



unsigned char EcrireRegistreMAX7219(unsigned char Instruction, unsigned char Donnee)
{
	while((SPI1->SR & 0x0080) == 0x0080);	/* Bouclage tant que le module du SPI1 signale qu'il est occup */

	GPIOA->BSRR = (1 << 0);	/* LOAD_MAX7219 = 1 */

	GPIOA->BSRR = (1 << (0 + 16));	/* LOAD_MAX7219 = 0 */

	SPI1->CR2 |= (1 << 7);	/* Autorisation des interruptions provoques par le module du SPI1 */

	SPI1->DR = ((Instruction << 8) | Donnee);	/* Des trames de 16 bits doivent tre
	envoyes au circuit intgr MAX7219.
	Les 8 bits de poids fort contiennent le code de l'instruction  effectuer.
	Les 8 bits de poids faible contiennent la donne associe  l'instruction.
	L'envoi des 16 bits par le module du SPI1 dmarre lorsque l'on crit dans le registre  SPI1->DR  */

	return 1;
}


