


#include <stm32f10x.h>

#include "SPI.h"
#include "MAX7219.h"
#include "Utilitaires.h"



int main(void)
{
	unsigned char Unites = 0;
	unsigned char Dizaines = 0;

	unsigned char k;
	unsigned char p;


	RCC->APB2ENR |= (1 << 2);	/* Activation de l'horloge du port A */
	

	
	InitSPI1();
	InitITSPI1();



	EcrireRegistreMAX7219(MAX7219_SHUTDOWN, 0x00);	/* Shutdown : placement en  Shutdown Mode  */

	EcrireRegistreMAX7219(MAX7219_DECODE_MODE, 0xFF);	/* Dcodage du code B pour tous les afficheurs, les
		octets de donnes envoys dfinissent les symboles  afficher */

	EcrireRegistreMAX7219(MAX7219_SCAN_LIMIT, 0x01);	/* Pilotage des 2 premiers afficheurs */

	EcrireRegistreMAX7219(MAX7219_INTENSITY, 0x0E);	/* Intensit du courant dlivr dans les diodes
		utilisant un rapport cyclique de 29 / 32.
		0x00 : 1 / 32, minimum,
		0x0E : 31 / 32, maximum. */

	EcrireRegistreMAX7219(MAX7219_DISPLAY_TEST, 0x00);	/* Dispaly Test : placement en  Normal Operation  */



	while(1)
	{
/* -------------------------------- Dbut de l'affichage des symboles du  Code B  -------------------------------- */

		EcrireRegistreMAX7219(MAX7219_SHUTDOWN, 0x01);	/* Shutdown : placement en  Normal Operation  */

		EcrireRegistreMAX7219(MAX7219_DIGIT_1, 0x0F);	/* Symbole 1, soit celui de gauche : envoi
			du code permettant l'extinction de l'afficheur */
		EcrireRegistreMAX7219(MAX7219_DIGIT_0, 0x0F);	/* Symbole 0, soit celui de droite : envoi
			du code permettant l'extinction de l'afficheur */


		for(k = 0x00; k <= 0x0F; k++)
		{
			EcrireRegistreMAX7219(MAX7219_DIGIT_1, 0x0F);	/* Symbole 1, soit celui de gauche : envoi
				du code permettant l'extinction de l'afficheur */
			EcrireRegistreMAX7219(MAX7219_DIGIT_0, k);	/* Symbole 0, soit celui de droite : envoi
				des codes utilisables */
			Delai(50000);
		}

		EcrireRegistreMAX7219(MAX7219_DIGIT_1, 0x0F);	/* Symbole 1, soit celui de gauche : envoi
			du code permettant l'extinction de l'afficheur */
		EcrireRegistreMAX7219(MAX7219_DIGIT_0, 0x0F);	/* Symbole 0, soit celui de droite : envoi
			du code permettant l'extinction de l'afficheur */

/* -------------------------------- Fin de l'affichage des symboles du  Code B  -------------------------------- */



/* -------------------------------- Dbut du comptage de 0  99 -------------------------------- */

		Dizaines = 0;
		Unites = 0;
		while(Dizaines < 10)
		{
			if(Dizaines == 0)	/* Si le nombre  afficher ne contient qu'un seul chiffre */
			{
				EcrireRegistreMAX7219(MAX7219_DIGIT_1, 0x0F);	/* Symbole 1, soit celui de gauche : envoi
					du code permettant l'extinction de l'afficheur */
			}
			else
			{
				EcrireRegistreMAX7219(MAX7219_DIGIT_1, Dizaines);	/* Symbole 1, soit celui de gauche : envoi
					du code permettant l'affichage du chiffre des dizaines */
			}
			EcrireRegistreMAX7219(MAX7219_DIGIT_0, (MAX7219_POINT_DECIMAL | Unites));	/* Symbole 0, soit celui de droite :  OU  bit--bit entre
				la donne permettant l'affichage du chiffre des units et le code permettant l'affichage du point dcimal */
			Delai(5000);
			if(Unites < 9)
			{
				Unites++;
			}
			else
			{
				Dizaines++;
				Unites = 0;
			}
		}

/* -------------------------------- Fin du comptage de 0  99 -------------------------------- */



/* -------------------------------- Dbut de l'affichage de symboles dfinis par l'utilisateur :  HA.  -------------------------------- */

		EcrireRegistreMAX7219(MAX7219_SHUTDOWN, 0x00);	/* Shutdown : placement en  Shutdown Mode  */
		EcrireRegistreMAX7219(MAX7219_DECODE_MODE, 0x00);	/* Aucun dcodage pour tous les afficheurs, les
			octets de donnes envoys dfinissent l'affichage */
		EcrireRegistreMAX7219(MAX7219_DIGIT_1, 0x37);	/* Symbole 1, soit celui de gauche : envoi
			du code permettant l'affichage du symbole H */
		EcrireRegistreMAX7219(MAX7219_DIGIT_0, (MAX7219_POINT_DECIMAL | 0x77));	/* Symbole 0, soit celui de droite :  OU  bit--bit entre
			la donne permettant l'affichage du symbole A et le code permettant l'affichage du point dcimal */
		EcrireRegistreMAX7219(MAX7219_SHUTDOWN, 0x01);	/* Shutdown : placement en  Normal Operation  */

	   	Delai(300000);

		EcrireRegistreMAX7219(MAX7219_SHUTDOWN, 0x00);	/* Shutdown : placement en  Shutdown Mode  */
		EcrireRegistreMAX7219(MAX7219_DECODE_MODE, 0xFF);	/* Dcodage du code B pour tous les afficheurs, les
			octets de donnes envoys dfinissent les symboles  afficher */
		EcrireRegistreMAX7219(MAX7219_INTENSITY, 0x00);	/* Intensit du courant dlivr dans les diodes minimale,
			utilisant un rapport cyclique de 1 / 32.
			0x00 : 1 / 32, minimum,
			0x0F : 31 / 32, maximum. */
		EcrireRegistreMAX7219(MAX7219_DIGIT_1, 0x0F);	/* Symbole 1, soit celui de gauche : envoi
				du code permettant l'extinction de l'afficheur */
		EcrireRegistreMAX7219(MAX7219_DIGIT_0, (MAX7219_POINT_DECIMAL | 0x00));	/* Symbole 0, soit celui de droite :  OU  bit--bit entre
			la donne permettant l'affichage du symbole 0 et le code permettant l'affichage du point dcimal */
		EcrireRegistreMAX7219(MAX7219_SHUTDOWN, 0x01);	/* Shutdown : placement en  Normal Operation  */

/* -------------------------------- Fin de l'affichage de symboles dfinis par l'utilisateur :  HA.  -------------------------------- */



/* -------------------------------- Dbut du test des afficheurs -------------------------------- */

		EcrireRegistreMAX7219(MAX7219_DISPLAY_TEST, 0x01);	/* Dispaly Test : placement en  Display Test Mode  */
	   	Delai(300000);
		EcrireRegistreMAX7219(MAX7219_DISPLAY_TEST, 0x00);	/* Dispaly Test : placement en  Normal Operation  */

/* -------------------------------- Fin du test des afficheurs -------------------------------- */



/* -------------------------------- Dbut des variations d'intensit lumineuse  -------------------------------- */

		for(k = 0; k < 10; k++)
		{
			for(p = 0; p <= 0x0F; p++)
			{
				EcrireRegistreMAX7219(MAX7219_INTENSITY, p);	/* Intensit du courant dlivr dans les diodes
					qui augmente progressivement, de 0x00 : rapport cyclique de 1 / 32, minimal, jusqu' 0x0E : rapport cyclique de 29 / 32 */
				Delai(1000);
			}
			for(p = 0x0E; p > 0x00; p--)
			{
				EcrireRegistreMAX7219(MAX7219_INTENSITY, p);	/* Intensit du courant dlivr dans les diodes
					qui diminue progressivement, de 0x0F : rapport cyclique de 31 / 32, maximal, jusqu' 0x00 : rapport cyclique de 1 / 32, minimal */
				Delai(1000);
			}
		}


		EcrireRegistreMAX7219(MAX7219_INTENSITY, 0x0E);	/* Intensit du courant dlivr dans les diodes
			utilisant un rapport cyclique de 29 / 32.
			0x00 : 1 / 32, minimum,
			0x0F : 31 / 32, maximum. */

/* -------------------------------- Fin des variations d'intensit lumineuse -------------------------------- */



/* -------------------------------- Dbut du clignotement du symbole  0  de droite -------------------------------- */

		p = 0x01;
		EcrireRegistreMAX7219(MAX7219_DIGIT_1, 0x0F);	/* Symbole 1, soit celui de gauche : envoi
			du code permettant l'extinction de l'afficheur */
		EcrireRegistreMAX7219(MAX7219_DIGIT_0, (MAX7219_POINT_DECIMAL | 0x00));	/*  OU  bit--bit entre
			le code permettant l'affichage du symbole 0 et le code permettant l'affichage du point dcimal */
		for(k = 0; k < 10; k++)
		{
			EcrireRegistreMAX7219(MAX7219_SHUTDOWN, p);	/* Shutdown : placement alternativement
				en  Normal Operation  , puis en  Shutdown Mode  ,
				produisant l'effet de clignotement */
			p ^= 0x01;
	   		Delai(10000);
		}

		EcrireRegistreMAX7219(MAX7219_SHUTDOWN, 0x01);	/* Shutdown : placement en  Normal Operation  */

/* -------------------------------- Fin du clignotement du symbole  0  de droite -------------------------------- */



/* -------------------------------- Dbut du clignotement du point dcimal -------------------------------- */

		p = MAX7219_POINT_DECIMAL;

		for(k = 0; k < 10; k++)
		{
			EcrireRegistreMAX7219(MAX7219_DIGIT_1, 0x0F);	/* Symbole 1, soit celui de gauche : envoi
				du code permettant l'extinction de l'afficheur */
			EcrireRegistreMAX7219(MAX7219_DIGIT_0, (p | 0x00));	/* Symbole 0, soit celui de droite : envoi
				d'un  OU  bit--bit entre le code permettant l'affichage du symbole 0 et le code permettant l'affichage du point dcimal,
				activ et dsactiv alternativement */
			p ^= MAX7219_POINT_DECIMAL;
	   		Delai(10000);
		}
		EcrireRegistreMAX7219(MAX7219_DIGIT_1, 0x0F);	/* Symbole 1, soit celui de gauche : envoi
			du code permettant l'extinction de l'afficheur */
		EcrireRegistreMAX7219(MAX7219_DIGIT_0, 0x0F);	/* Symbole 0, soit celui de droite : envoi
			du code permettant l'extinction de l'afficheur */

/* -------------------------------- Fin de l'effet  Clignotement du point dcimal  -------------------------------- */

	}
}



/*Fonction qui permet l'initialisation du microcontrleur STM32F100RB

Paramtre d'entre :

Aucun.

Valeur de retour :

Aucune.

*/
void SystemInit (void)
{
	RCC->CR |= 0x01;
	while((RCC->CR & ~(1 << 1)) == 0x00);
	RCC->CR |= (1 << 16);
	while((RCC->CR & ~(1 << 17)) == 0x00);
	
	RCC->CFGR |= (4 << 18);
	RCC->CFGR |= (1 << 16);
	
	RCC->CFGR |= 0x02;
	
	RCC->CR |= (1 << 24);
	while((RCC->CR & ~(1 << 24)) == 0x00);
	RCC->CFGR |= 0x02;
}


